﻿Public Class Form1

    Public DT_Output As New DataSet


    Private Sub Btn_Fill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Fill.Click
        Dim i1, i2, i3, numsheets, numcolumns, numrows As Integer
        Dim random1 As New Random
        Dim numeric As New FarPoint.Win.Spread.CellType.GeneralCellType

        numeric.FormatString = "E"
        numsheets = 400
        numcolumns = 50
        numrows = 200

        DT_Output.Clear()

        For i1 = 0 To numsheets
            DT_Output.Tables.Add()
            For i2 = 0 To numcolumns
                Dim colDecimal As DataColumn = New DataColumn("Col" & i2)
                colDecimal.DataType = System.Type.GetType("System.Decimal")
                DT_Output.Tables(i1).Columns.Add(colDecimal)
            Next
            For i2 = 0 To numrows
                DT_Output.Tables(i1).Rows.Add()
            Next
        Next


        For i1 = 0 To numsheets
            For i2 = 0 To numcolumns
                For i3 = 0 To numrows
                    DT_Output.Tables(i1).Rows(i3).Item(i2) = random1.Next(0, 1000000) * 0.000001
                Next
            Next
        Next

        FpSpread1.Sheets.Clear()
        For i1 = 0 To numsheets
            Dim sv As New FarPoint.Win.Spread.SheetView("Sheet " & i1)
            FpSpread1.Sheets.Add(sv)
            FpSpread1.Sheets(i1).DataSource = DT_Output.Tables(i1)
            FpSpread1.Sheets(i1).Protect = False
            For i2 = 0 To numrows
                For i3 = 0 To numcolumns
                    FpSpread1.Sheets(i1).Cells(i2, i3).CellType = numeric
                Next
            Next
        Next

    End Sub

    Private Sub Btn_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Save.Click
        Save1.Filter = "xls files (*.xls)|*.xls|All files (*.*)|*.*"
        Save1.InitialDirectory = Application.StartupPath
        Save1.FileName = ""
        Save1.ShowDialog()
        If Save1.FileName <> "" Then
            FpSpread1.SaveExcel(Save1.FileName) ',FarPoint.Excel.ExcelSaveFlags.UseOOXMLFormat,
        End If
    End Sub
End Class
